Debian Bug report logs - #422879
sbuild doesn't always deal well with build-depends resolution

version graph

Package: sbuild; Maintainer for sbuild is Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>; Source for sbuild is src:sbuild.

Reported by: Lucas Nussbaum <lucas@lucas-nussbaum.net>

Date: Tue, 8 May 2007 15:39:06 UTC

Severity: important

Tags: confirmed, fixed-upstream, patch

Merged with 395271

Found in version sbuild/0.53

Fixed in version sbuild/0.57.4-1

Done: Roger Leigh <rleigh@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#422879; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
New Bug report received and forwarded. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: submit@bugs.debian.org
Subject: sbuild doesn't always deal well with build-depends resolution
Date: Tue, 8 May 2007 17:37:55 +0200
Package: sbuild
Version: 0.53
Severity: important

Hi Roger,

I ran a build of all packages in sid using sbuild 0.53. I haven't
analyzed all the failures (~500) yet, but there's a class of failures
that is caused directly by sbuild.

When a package build-depends on a | b, and a is uninstallable, it
doesn't try to b. That's already known as bug #403246.

But when a package build-depends on a | b, and a is installable, it
installs a, even if this prevents another build-dependancy to be
installed.

Exemples follow, for all the failures I could link to sbuild problems.
You can read all logs in
gluck:~lucas/public_html/logs/2007/05/rebuild.sid.i386/

avr-libc:
Build-Depends: gcc-avr (>= 1:4.1.0-1), debhelper (>= 5), doxygen (>=
1.3.4-1), tetex-bin (<= 3.0-30) | texlive-extra-utils (>= 200
7-4), tetex-extra | texlive-extra-utils (>= 2007-4), transfig, gs,
netpbm, x11-common
Installs tetex-bin 2007-4, then realizes that it doesn't fit the
Build-Depends rule:
After installing, the following source dependencies are still unsatisfied:
tetex-bin(inst 2007-4 ! <= wanted 3.0-30)|texlive-extra-utils(missing)
Source-dependencies not satisfied; skipping avr-libc

crystalspace:
Build-Depends: debhelper (>= 4.0), python2.3-dev | python2.2-dev |
python-dev, [...]
Tries to install python2.3-dev, then fails, while python-dev is
available. (#403246)

libclass-trait-perl:
Build-Depends: debhelper (>= 4.0.2)
Build-Depends-Indep: perl (>= 5.8.0-7), libtest-differences-perl (>=
0.47), libmodule-build-perl, libtest-simple-perl (>= 0.62)
Checking for already installed source dependencies...
debhelper: missing
Using default version 5.0.49
perl: already installed (5.8.8-7 >= 5.8.0-7 is satisfied)
libtest-differences-perl: missing
Using default version 0.47-2
libmodule-build-perl: missing
libtest-simple-perl: already installed (=*=PROVIDED=*= >= 0.62 is
satisfied)
[...]
dpkg-buildpackage: source package is libclass-trait-perl
dpkg-buildpackage: source version is 0.22-2
dpkg-buildpackage: host architecture i386
dpkg-buildpackage: source version without epoch 0.22-2
dpkg-checkbuilddeps: Unmet build dependencies: libtest-simple-perl (>=
0.62)
dpkg-buildpackage: Build dependencies/conflicts unsatisfied; aborting.

libtest-simple-perl is Provided by perl-modules, but a versioned depends should install the real package, not use the Provide.

libmail-box-perl:
same problem as libtest-simple-perl, but with libscalar-list-utils-perl
and libtest-harness-perl

libtest-base-perl:
also build-depends on libtest-simple-perl.

libwww-perl:
build-dpends on libnet-perl, also provided by perl-modules.

Isn't it possible to use 'apt-get build-dep', or to copy its algorithm ?

Thank you for your work on sbuild. It works amazingly well on all other
packages.
-- 
| Lucas Nussbaum
| lucas@lucas-nussbaum.net   http://www.lucas-nussbaum.net/ |
| jabber: lucas@nussbaum.fr             GPG: 1024D/023B3F4F |



Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#422879; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Michael Banck <mbanck@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #10 received at 422879@bugs.debian.org (full text, mbox):

From: Michael Banck <mbanck@debian.org>
To: Lucas Nussbaum <lucas@lucas-nussbaum.net>, 422879@bugs.debian.org
Subject: Re: Bug#422879: sbuild doesn't always deal well with build-depends resolution
Date: Tue, 8 May 2007 19:28:32 +0200
On Tue, May 08, 2007 at 05:37:55PM +0200, Lucas Nussbaum wrote:
> When a package build-depends on a | b, and a is uninstallable, it
> doesn't try to b. That's already known as bug #403246.
> 
> But when a package build-depends on a | b, and a is installable, it
> installs a, even if this prevents another build-dependancy to be
> installed.
 
As I understand it, that's the intended upstream behaviour.

> Isn't it possible to use 'apt-get build-dep', or to copy its algorithm ?

I think Ryan said he wouldn't change wanna-build's sbuild to that, I
have no opinion on what the packaged sbuild should do.


Michael



Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#422879; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #15 received at 422879@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: Michael Banck <mbanck@debian.org>
Cc: 422879@bugs.debian.org
Subject: Re: Bug#422879: sbuild doesn't always deal well with build-depends resolution
Date: Tue, 8 May 2007 21:02:07 +0200
On 08/05/07 at 19:28 +0200, Michael Banck wrote:
> On Tue, May 08, 2007 at 05:37:55PM +0200, Lucas Nussbaum wrote:
> > When a package build-depends on a | b, and a is uninstallable, it
> > doesn't try to b. That's already known as bug #403246.
> > 
> > But when a package build-depends on a | b, and a is installable, it
> > installs a, even if this prevents another build-dependancy to be
> > installed.
>  
> As I understand it, that's the intended upstream behaviour.

Ah true. An example is crystalspace:
http://buildd.debian.org/fetch.cgi?pkg=crystalspace;ver=0.99-20060125-2;arch=alpha;stamp=1169975707

But there's still is a bug with a way sbuild deals with Provides vs
versioned Depends.
-- 
| Lucas Nussbaum
| lucas@lucas-nussbaum.net   http://www.lucas-nussbaum.net/ |
| jabber: lucas@nussbaum.fr             GPG: 1024D/023B3F4F |



Information forwarded to debian-bugs-dist@lists.debian.org, Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>:
Bug#422879; Package sbuild. Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Extra info received and forwarded to list. Copy sent to Debian buildd-tools Developers <buildd-tools-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #20 received at 422879@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: 422879@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Re: Bug#422879: sbuild doesn't always deal well with build-depends resolution
Date: Mon, 26 May 2008 10:48:20 +0200
forcemerge 395271 422879
thanks

On 08/05/07 at 21:02 +0200, Lucas Nussbaum wrote:
> But there's still is a bug with a way sbuild deals with Provides vs
> versioned Depends.

... but this is already filed as #395271, so merging.
-- 
| Lucas Nussbaum
| lucas@lucas-nussbaum.net   http://www.lucas-nussbaum.net/ |
| jabber: lucas@nussbaum.fr             GPG: 1024D/023B3F4F |




Forcibly Merged 395271 422879. Request was from Lucas Nussbaum <lucas@lucas-nussbaum.net> to control@bugs.debian.org. (Mon, 26 May 2008 06:57:03 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 15 Aug 2008 07:37:59 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 06:33:02 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.